package com.zztrapp.zztrapp.ui.index.adapter;


import android.annotation.SuppressLint;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.google.android.flexbox.FlexboxLayoutManager;
import com.zztrapp.zztrapp.bean.WsclssIndexBean;
import com.zztrapp.zztrapp.databinding.ItemRvSpecialTasksBinding;
import com.zztrapp.zztrapp.ui.currency.adapter.FlexBoxItemAdapter;

import java.util.ArrayList;
import java.util.List;

/**
 * Describe 污水处理设施-首页
 * Created by Bby on 2022/6/23
 * Email bby0856@163.com
 */

public class WsclssPagelistAdapter extends RecyclerView.Adapter<WsclssPagelistAdapter.ItemHolder> {

    private Context mContext;
    private OnItemClickListener onItemClickListener;
    private List<WsclssIndexBean.RecordsBean> list;

    public interface OnItemClickListener {
        void onEditClick(String id, int position);

        void onLookDetailClick(String id, int position);

        void onDailyTasksClick(String id);
    }

    public void setOnItemClickListener(OnItemClickListener onItemClickListener) {
        this.onItemClickListener = onItemClickListener;
    }

    public WsclssPagelistAdapter(Context context) {
        this.mContext = context;
    }

    public void setData(List<WsclssIndexBean.RecordsBean> list) {
        this.list = list;
        notifyDataSetChanged();
    }

    @NonNull
    @Override
    public ItemHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        ItemRvSpecialTasksBinding binding = ItemRvSpecialTasksBinding.inflate(LayoutInflater.from(mContext), parent, false);
        return new ItemHolder(binding);
    }

    @Override
    public void onBindViewHolder(ItemHolder holder, @SuppressLint("RecyclerView") int position) {
        holder.bindings.dailyTasks.setVisibility(View.VISIBLE);
        holder.bindings.taskName.setText("设备名称 " + list.get(position).getSbmc());
        List<String> arrayList = new ArrayList<>();
        arrayList.add("设备编号：" + list.get(position).getSbbh());
        arrayList.add("行政区划：" + list.get(position).getCountyName());
        arrayList.add("经度：" + list.get(position).getSbscwzjd());
        arrayList.add("纬度：" + list.get(position).getSbscwzwd());
        arrayList.add("设计规模 (吨/日)：" + list.get(position).getSjgm());
        switch (Integer.parseInt(list.get(position).getYxzt())) {//
            case 0:
                arrayList.add("运行状态：停止运行");
                break;
            case 1:
                arrayList.add("运行状态：正常运行");
                break;
        }

        holder.bindings.rv.setLayoutManager(new FlexboxLayoutManager(mContext));
        FlexBoxItemAdapter adapter = new FlexBoxItemAdapter(mContext);
        holder.bindings.rv.setAdapter(adapter);
        adapter.setData(arrayList);

        holder.bindings.edit.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (onItemClickListener != null) {
                    onItemClickListener.onEditClick(list.get(position).getId(), position);
                }
            }
        });
        holder.bindings.lookDetail.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (onItemClickListener != null) {
                    onItemClickListener.onLookDetailClick(list.get(position).getId(), position);
                }
            }
        });
        holder.bindings.dailyTasks.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (onItemClickListener != null) {
                    onItemClickListener.onDailyTasksClick(list.get(position).getId());
                }
            }
        });
    }

    @Override
    public int getItemCount() {
        return list != null ? list.size() : 0;
    }

    static class ItemHolder extends RecyclerView.ViewHolder {
        private ItemRvSpecialTasksBinding bindings;

        public ItemHolder(ItemRvSpecialTasksBinding binding) {
            super(binding.getRoot());
            bindings = binding;
        }
    }
}